#include "RotatingObject3D.h"

/**
 * Updates the rotating object, ie rotates it and updates the world space vertices.
 */
void RotatingObject3D::update(float dt) {
    this->rotation = rotation + dt * this->rotationSpeed;
    this->updatedModel = glm::rotate(this->model, this->rotation, glm::vec3(0.0, 0.0, 1.0));
    updateWorldVertices();
}

/**
 * Setter for the rotation speed.
 */
void RotatingObject3D::setRotationSpeed(float in_rotationSpeed) {
    rotationSpeed = in_rotationSpeed;
}

/**
 * Overwrite the getModel() setter to return the updated model matrix.
 * Original model matrix will always stay the same.
 */
glm::mat4 RotatingObject3D::getModel() {

    return this->updatedModel;
}
