#ifndef ROTATINGOBJECT3D_H
#define ROTATINGOBJECT3D_H
#include "glm/glm.hpp"
#include "glm/gtc/matrix_transform.hpp"
#include "Object3D.h"

/**
 * Extended from the Object3D, this class has a rotationSpeed that is used to rotate the object:
 *  - Update the model matrix
 *  - Update the world vertices based on the rotationSpeed and elapsed time (dt).
 */
class RotatingObject3D : public Object3D
{
    public:
        RotatingObject3D(std::vector<glm::vec3> vertices, glm::mat4 model, GLuint vaoHandle) : Object3D(vertices, model, vaoHandle) {};
        void setRotationSpeed(float rotationSpeed);
        void update(float dt);
        glm::mat4 getModel();
    protected:
        float rotationSpeed;
        float rotation;
        glm::mat4 updatedModel;
    private:
};

#endif // ROTATINGOBJECT3D_H
